> For the complete documentation index, see [llms.txt](https://docs.hackle.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hackle.io/en/development-guide/react-native/user-identifier/react-native-user-info-crm.md).

# CRM Properties

CRM Properties are stored securely only on the Hackle server and cannot be directly retrieved through the SDK.

{% hint style="danger" %}
CRM Properties are managed separately and are not deleted or reset when you call `resetUser()` or `clearAll` in `updateUserProperties`.

If a user withdraws their account, you must call the separately provided functions to delete the information.
{% endhint %}

## Phone Number Collection

{% hint style="info" %}
This feature is supported in React Native SDK version 3.20.0 and above.
{% endhint %}

{% hint style="success" %}
Kakao / SMS Message Recommendation

By using this feature to map user identifiers to phone numbers, you can use Hackle for Kakao / SMS messaging more smoothly.
{% endhint %}

#### setPhoneNumber

Registers the user's phone number.

The phone number is saved only if it is in a valid E.164 format. If no country code is specified, South Korea (+82) is used as the default.

If the user already has a saved phone number, calling this function replaces the existing phone number with the new value.

```javascript
const myPhone = '+821012341234';
hackleClient.setPhoneNumber(myPhone);
```

#### unsetPhoneNumber

Deletes the phone number registered for the user.

```javascript
hackleClient.unsetPhoneNumber();
```

## CRM Marketing Message Subscription Consent

{% hint style="info" %}
This feature is supported in React Native SDK version 3.24.0 and above.

For details on subscription consent status, refer to the [CRM Message Subscription Consent Management documentation](/en/development-guide/sdk/user-identifier/crm-subscription.md).
{% endhint %}

### Subscription Consent Properties

You can subscribe or unsubscribe by message purpose.

Use `HackleSubscriptionOperationsBuilder` to set the consent status for the desired properties, then finalize the update with a method such as `updatePushSubscriptions()`.

You can update the consent status per message channel.

```javascript
import { HackleSubscriptionOperationsBuilder, HackleSubscriptionStatus } from "@hackler/react-native-sdk"

const operations = new HackleSubscriptionOperationsBuilder()
  .marketing(HackleSubscriptionStatus.SUBSCRIBED)
  .information(HackleSubscriptionStatus.SUBSCRIBED)
  .build()

hackleClient.updatePushSubscriptions(operations);
```

#### Promotional Messages

Sets the subscription consent property for promotional messages.

```javascript
import { HackleSubscriptionOperationsBuilder, HackleSubscriptionStatus } from "@hackler/react-native-sdk"

const operations = new HackleSubscriptionOperationsBuilder()
  .marketing(HackleSubscriptionStatus.SUBSCRIBED)
  .build()

hackleClient.updatePushSubscriptions(operations);
```

#### Informational Messages

Sets the subscription consent property for informational messages.

```javascript
import { HackleSubscriptionOperationsBuilder, HackleSubscriptionStatus } from "@hackler/react-native-sdk"

const operations = new HackleSubscriptionOperationsBuilder()
  .information(HackleSubscriptionStatus.SUBSCRIBED)
  .build()

hackleClient.updatePushSubscriptions(operations);
```

<table><thead><tr><th width="224.09765625">HackleSubscriptionStatus</th><th>Description</th></tr></thead><tbody><tr><td><code>UNKNOWN</code></td><td>Subscription Consent has not been given or denied (<code>default</code>)</td></tr><tr><td><code>SUBSCRIPTION</code></td><td>Explicitly opted in to receive messages</td></tr><tr><td><code>UNSUBSCRIPTION</code></td><td>Explicitly opted out of receiving messages</td></tr></tbody></table>

### Update Push Subscription Consent Status

Updates the user's push message subscription consent status.

```javascript
import { HackleSubscriptionOperationsBuilder, HackleSubscriptionStatus } from "@hackler/react-native-sdk"

const operations = new HackleSubscriptionOperationsBuilder()
  .marketing(HackleSubscriptionStatus.SUBSCRIBED)
  .information(HackleSubscriptionStatus.SUBSCRIBED)
  .build()

hackleClient.updatePushSubscriptions(operations);
```

### Update Kakao Message Subscription Consent Status

Updates the user's Kakao message subscription consent status.

```javascript
import { HackleSubscriptionOperationsBuilder, HackleSubscriptionStatus } from "@hackler/react-native-sdk"

const operations = new HackleSubscriptionOperationsBuilder()
  .marketing(HackleSubscriptionStatus.SUBSCRIBED)
  .information(HackleSubscriptionStatus.SUBSCRIBED)
  .build()

hackleClient.updateKakaoSubscriptions(operations);
```

### Update SMS Message Subscription Consent Status

Updates the user's SMS message subscription consent status.

```javascript
import { HackleSubscriptionOperationsBuilder, HackleSubscriptionStatus } from "@hackler/react-native-sdk"

const operations = new HackleSubscriptionOperationsBuilder()
  .marketing(HackleSubscriptionStatus.SUBSCRIBED)
  .information(HackleSubscriptionStatus.SUBSCRIBED)
  .build()

hackleClient.updateSmsSubscriptions(operations);
```

<table><thead><tr><th width="224.09765625">HackleSubscriptionStatus</th><th>Description</th></tr></thead><tbody><tr><td><code>UNKNOWN</code></td><td>Subscription Consent has not been given or denied (<code>default</code>)</td></tr><tr><td><code>SUBSCRIPTION</code></td><td>Explicitly opted in to receive messages</td></tr><tr><td><code>UNSUBSCRIPTION</code></td><td>Explicitly opted out of receiving messages</td></tr></tbody></table>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.hackle.io/en/development-guide/react-native/user-identifier/react-native-user-info-crm.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
